﻿XIncludeFile "OWire_Module.pbi"

UseModule OWire

Enumeration FormFont
  #FontBigT
EndEnumeration

LoadFont(#FontBigT,"Open Sans", 48, #PB_Font_Bold)

Enumeration Window
  #WinMain
EndEnumeration

Enumeration Menu
  #Menu_Main
  #Menu_TablePopup
EndEnumeration

Enumeration Gadget
  #ComboPort
  #Table
  #TextD1
  #TextD2
  #TextD3
EndEnumeration

Enumeration
  #MItem_Log
  #MItem_Exit
  #MItem_Rename
  #MItem_DelSensor
EndEnumeration

Enumeration StatusBar
  #StatusBar_Main
EndEnumeration

Enumeration
  #StatusBar_Main_Status
EndEnumeration

Enumeration
  #Table_Name
  #Table_Type
  #Table_SN
  #Table_Power
  #Table_Thermo
  #Table_Status
  #Table_Time
EndEnumeration

Enumeration Image
  #ImageShem
EndEnumeration

Enumeration File
  #LogFileID
EndEnumeration

#Table_Color_Err  = $8888FD
#Table_Color_Warn = $ABF9FF

#DI_ErrFlag_CRC_ROM  = 1
#DI_ErrFlag_CRC_RAM  = 1<<1
#DI_ErrFlag_Thermo   = 1<<2
#DI_ErrFlag_OW       = 1<<3
#DI_ErrFlag_NotFound = 1<<4 

#Event_GUI_Update = #PB_Event_FirstCustomValue + 2

#GUI_Update_Table_Flag_Text  = 1
#GUI_Update_Table_Flag_Color = 1<<1
#GUI_Update_Flag_Table = 1
#GUI_Update_Flag_StatusBar = 1<<1

#PortName = "COM"

; -- FOR CHART --
Structure Meter 
  PBimg.l 
  width.l 
  height.l 
  offset.l 
  valuesA.f[2048] 
  valuesB.f[2048]
  valuesC.f[2048]
EndStructure 
; -- END FOR CHART --

Structure DevicesInfo
  SN.OW_SN
  Thermo.f
  ErrFlag.a
EndStructure

Structure ThreadParam
  BreakTh.a      ; Если #True, то нужно завершить работу потока.
  PortChange.a   ; Если #True, то выбран другой порт.
  ConvertOnly.a
  ThermoInterval.u 
  Log.a
  Port.s
  List SensorList.OW_SN()
EndStructure

Structure GUI_Update_Table_Item
  Text.s
  Color.l
  Flags.a
EndStructure

Structure GUI_Update_Table
  Item.GUI_Update_Table_Item[#Table_Status+2]
  SN.OW_SN
  IsFound.a
EndStructure

Structure GUI_Update
  Mutex.i
  List Table.GUI_Update_Table()
  StatusBarText.s
  Flags.a
EndStructure

Define Thread_OW_ID, Event, Window, x
Define Drag_TablePos=-1, String.s
Global TheGraph =0

Global NewList g_TableList.GUI_Update_Table()
Global gOW_Thread.ThreadParam
Global gGUI_Update.GUI_Update\Mutex = CreateMutex()
gOW_Thread\BreakTh    = #False
gOW_Thread\PortChange = #False

;Актуальные показания термодатчиков
Global Dim termoData.f(3)
For i=0 To 2
  termoData(i)=0
Next i
;
Global LowChartLevel = 75
Global MaxChartLevel = 100
;
Global ColorCub = RGB(20,197,68)            
Global ColorTsarga = RGB(20,197,68)       
Global ColorTroinik = RGB(20,197,68)  
Global ColorTempFon = RGB(0,0,0)
Global ColorSetka = RGB(48,48,48)
;
Procedure.s GetLastErrorString(Err)
  Protected String.s
  
  Select Err
    Case #OW_Err_OK       : String = "Нет ошибок"
    Case #OW_Err_Port     : String = "Нет открытого COM порта"
    Case #OW_Err_NoDevice : String = "Нет ответа от '1-Wire' устройств"
    Case #OW_Err_IO       : String = "Ошибка обмена данными"
    Case #OW_Err_BaudRate : String = "Ошибка изменения скорости порта"
    Case #OW_Err_Search   : String = "Ошибка при поиске '1-Wire' устройств"
    Case #OW_Err_BadParam : String = "Ошибка в аргументе функции"
    Case #OW_Err_NoData   : String = "Нет данных"
  EndSelect
  
  ProcedureReturn String
EndProcedure

Procedure WriteLog(String.s)
  If IsFile(#LogFileID)=0
    If OpenFile(#LogFileID,FormatDate("%yyyy.%mm.%dd-%hh.%ii", Date()) + ".DS18x20.csv")
      If Lof(#LogFileID)<=0
        WriteStringFormat(#LogFileID, #PB_UTF8)
      Else
        FileSeek(#LogFileID, Lof(#LogFileID))
      EndIf
      Goto _next
    EndIf
  Else
    _next:
    If String<>""
      ReplaceString(String, Chr($a), " ", #PB_String_InPlace)
      ReplaceString(String, Chr($d), " ", #PB_String_InPlace)
      String = FormatDate("%dd.%mm.%yyyy,", Date()) + FormatDate("%hh:%ii:%ss,", Date()) + String
    EndIf
    WriteStringN(#LogFileID, String, #PB_UTF8)
    FlushFileBuffers(#LogFileID)
  EndIf
EndProcedure

Procedure.s wordform(num.i, form_one.s, form_two.s, form_three.s) 
  num % 100 
  Protected num_two.i = num % 10 
  If num > 10 And num < 20 
    ProcedureReturn form_three 
  EndIf 
  If num_two > 1 And num_two < 5 
    ProcedureReturn form_two 
  EndIf 
  If num_two = 1
    ProcedureReturn form_one 
  EndIf 
  ProcedureReturn form_three 
EndProcedure

Procedure.s SN_Text(*x.OW_SN)
  Protected String.s, i
  
  String = RSet(Hex(*x\Type), 2, "0")+"-"
  
  For i=5 To 0 Step -1
    String + RSet(Hex(*x\Number[i]), 2, "0")
  Next i
  
  String + "-"+RSet(Hex(*x\CRC), 2, "0")
  
  ProcedureReturn String
EndProcedure

Macro SetTableText(Object, Pos, String)
  Object\Table()\Item[Pos]\Text = String
  Object\Table()\Item[Pos]\Flags | #GUI_Update_Table_Flag_Text
  Object\Flags | #GUI_Update_Flag_Table
EndMacro

Macro SetTableColor(Object, Pos, Color_)
  Object\Table()\Item[Pos]\Color = Color_
  Object\Table()\Item[Pos]\Flags | #GUI_Update_Table_Flag_Color
  Object\Flags | #GUI_Update_Flag_Table
EndMacro

Macro SetStatusBarText(Object, String)
  Object\StatusBarText = String
  Object\Flags | #GUI_Update_Flag_StatusBar
EndMacro

Procedure UpdateTableAll(List Devices.DevicesInfo(), *GUI.GUI_Update)
  Protected String.s
  
  ClearList(*GUI\Table())
  ForEach Devices()
    
    If AddElement(*GUI\Table())
      
      *GUI\Table()\SN = Devices()\SN
      
      Select Devices()\SN\Type
        Case $10
          String="DS1820 / DS18S20"
        Case $28
          String="DS18B20"
        Default
          String="Неизвестное устройство"
      EndSelect

      SetTableText(*GUI, #Table_Type, String)
      
      String=SN_Text(@Devices()\SN)
      If OW_GetCRC(Devices()\SN, 7) <> Devices()\SN\CRC
        String+"  ОШИБКА CRC"
        Devices()\ErrFlag | #DI_ErrFlag_CRC_ROM
        SetTableColor(*GUI, #Table_SN, #Table_Color_Err)
      EndIf
      
      SetTableText(*GUI, #Table_SN, String)
      
      If OW_SelectROM(Devices()\SN)
        If OW_ReadPowerSupply()
          String="3 pin"
        Else
          String="2 pin"
        EndIf
      Else
        String="Error"
      EndIf
      
      SetTableText(*GUI, #Table_Power, String)
      
      If Devices()\SN\Type=$10 Or Devices()\SN\Type=$28
        SetTableText(*GUI, #Table_Thermo, "Измерение")
        SetTableText(*GUI, #Table_Status, "Запуск")
        SetTableText(*GUI, #Table_Time, "Ждите")
      EndIf
      
    EndIf
  Next
  
EndProcedure

Procedure SearchSensor(List Devices.DevicesInfo(), Port.s, *GUI.GUI_Update)
  Protected Sensor.OW_SN, x=0
  
  StatusBarText(#StatusBar_Main, #StatusBar_Main_Status, "Поиск '1-Wire' устройств...")
    
  If ListSize(Devices())>0
    ClearList(Devices())
  EndIf
    
  OW_SearchROM_Reset()
  
  While OW_SearchROM_Enum(@Sensor)=#True
    x+1
    If AddElement(Devices())
      CopyStructure(@Sensor, @Devices()\SN, OW_SN)
    EndIf
  Wend
    
  If x>0 
    UpdateTableAll(Devices(), *GUI)
    StatusBarText(#StatusBar_Main, #StatusBar_Main_Status,
                  "Найдено "+x+" '1-Wire' "+wordform(x, "устройство", " устройства", " устройств")+".")
  Else
    StatusBarText(#StatusBar_Main, #StatusBar_Main_Status,
                  "На порту "+Port+", '1-Wire' устройства не найдены.")
    ClearList(*GUI\Table())
    *GUI\Flags | (#GUI_Update_Flag_StatusBar | #GUI_Update_Flag_Table)
  EndIf
EndProcedure

Procedure SelectPort(Port.s, List Devices.DevicesInfo(), *GUI.GUI_Update, NoSearch=#False)
   
  OW_ClosePort()
  
  If Port<>""
    If OW_OpenPort(Port)
      SetStatusBarText(*GUI, "Порт открыт")
    Else
      SetStatusBarText(*GUI, "Не удалось открыть порт '"+Port+
                          "'  Возможно он зянят или отстуствует в системе")
    EndIf
  EndIf
  
  *GUI\Flags | (#GUI_Update_Flag_StatusBar | #GUI_Update_Flag_Table)
  
  If NoSearch=#False
    ClearList(Devices())
    ClearList(*GUI\Table())
    
    If OW_GetLastError() = #OW_Err_OK   ; Ошибок нет.
      SearchSensor(Devices(), Port, *GUI)
    EndIf
    
  EndIf
  
EndProcedure

Procedure GUI_UpdateInfo(*GUI.GUI_Update)
  If *GUI\Flags
    
    LockMutex(gGUI_Update\Mutex)
    gGUI_Update\Flags=*GUI\Flags
    
    If *GUI\Flags & #GUI_Update_Flag_Table
      CopyList(*GUI\Table(), gGUI_Update\Table())
    EndIf
    
    If *GUI\Flags & #GUI_Update_Flag_StatusBar
      gGUI_Update\StatusBarText=*GUI\StatusBarText
    EndIf
    
    UnlockMutex(gGUI_Update\Mutex)
    
    PostEvent(#Event_GUI_Update, #WinMain, 0)
    
    *GUI\Flags=0
  EndIf
EndProcedure

Procedure Thread_OW(*Bool)
  Protected NewList Devices.DevicesInfo()
  Protected String.s, Count, i, Err
  Protected x.w, Thermo.f, RAM.OW_RAM
  Protected CountErr, OldCountErr
  Protected GUI.GUI_Update, Port.s
  
  ForEach gOW_Thread\SensorList()
    If AddElement(Devices())
      Devices()\SN = gOW_Thread\SensorList()
    EndIf
  Next
  
  Count = ListSize(Devices())
  Port=gOW_Thread\Port
  SelectPort(Port, Devices(), @GUI, #True)
  UpdateTableAll(Devices(), @GUI)
  GUI_UpdateInfo(@GUI)
  
  Repeat
    
    Delay(100)
    
    GUI\Flags = 0
    
    If gOW_Thread\PortChange
      Port=gOW_Thread\Port
      SelectPort(Port, Devices(), @GUI)
      Count = ListSize(Devices())
      gOW_Thread\PortChange = #False
      GUI_UpdateInfo(@GUI)
    EndIf
    
    If Count>0
      If OW_SkipROM()=#False
        String = GetLastErrorString(OW_GetLastError())
        SetStatusBarText(GUI, String)
        Err=#True
        Goto M1
      Else
          
        If OW_ConvertT()=#False
          String = GetLastErrorString(OW_GetLastError())
          SetStatusBarText(GUI, String)
          Err=#True
          Goto M1
        Else
          
          CountErr=0
          
          For i=1 To 8
            Delay(100)
            If gOW_Thread\PortChange
              Break
            ElseIf gOW_Thread\BreakTh
              Break 2
            EndIf
          Next i
                      
            i=0
            ForEach Devices()
              
              If SelectElement(GUI\Table(), i)
                
                For x=#Table_Type To #Table_Time
                  GUI\Table()\Item[x]\Flags=0
                Next x
                
                If Devices()\SN\Type = $10 Or ; DS1820 / DS18S20
                   Devices()\SN\Type = $28    ; DS18B20
                  
                  If OW_SelectROM(@Devices()\SN)
                    If OW_ReadRAM(@RAM)
                      x=(RAM\H_Termo<<8)|RAM\L_Termo
                      If Devices()\SN\Type = $28 
                        Thermo=x/16
                      Else
                        Thermo=x/2
                      EndIf
                      Devices()\Thermo = Thermo
                      SetTableText(GUI, #Table_Thermo, StrF(Thermo, 2)+" °C")
                      termoData(i) = Thermo
                      SetTableText(GUI, #Table_Time, FormatDate("%hh:%ii:%ss", Date()))
                      
                      If gOW_Thread\Log
                        WriteLog(SN_Text(@Devices()\SN)+","+StrF(Thermo, 1))
                      EndIf
                      If OW_GetCRC(@RAM, 8)=RAM\CRC
                        Devices()\ErrFlag & ~#DI_ErrFlag_CRC_RAM
                        SetTableText(GUI, #Table_Status, "OK")
                        SetTableColor(GUI, #Table_Status, -1)
                      Else
                        Devices()\ErrFlag | #DI_ErrFlag_CRC_RAM
                        SetTableText(GUI, #Table_Status, "Ошибка CRC")
                        SetTableColor(GUI, #Table_Status, #Table_Color_Err)
                      EndIf
                    EndIf
                  EndIf
                  
                  If OW_GetLastError()<>#OW_Err_OK 
                    Devices()\ErrFlag | #DI_ErrFlag_OW
                    SetTableText(GUI, #Table_Status, GetLastErrorString(OW_GetLastError()))
                    SetTableColor(GUI, #Table_Status, #Table_Color_Err)
                  ElseIf Devices()\ErrFlag & #DI_ErrFlag_CRC_RAM = 0
                    Devices()\ErrFlag & ~#DI_ErrFlag_OW
                    SetTableColor(GUI, #Table_Status, -1)
                  EndIf
                  
                EndIf
                
                If Devices()\ErrFlag
                  CountErr+1
                  If Devices()\ErrFlag & ~#DI_ErrFlag_CRC_ROM
                    SetTableText(GUI, #Table_Thermo, "")
                    SetTableText(GUI, #Table_Time, "")
                  EndIf
                EndIf
                
              EndIf
              
              i+1
            Next
            
            If Err=#True Or CountErr<>OldCountErr 
              
              If CountErr>0
                String=".    "+wordform(CountErr, "Обнаружен ", "Обнаружено ", "Обнаружены ")+
                       CountErr+wordform(CountErr, " датчик", " датчика", " датчиков")+" с ошибками в работе"
              Else
                String="."
              EndIf
              
              SetStatusBarText(GUI, "Найдено "+Count+" '1-Wire' "+
                            wordform(Count, "устройство", " устройства", " устройств")+String)
                            
              Err=#False
              OldCountErr = CountErr
            EndIf
            
          GUI_UpdateInfo(@GUI)
          
          If gOW_Thread\ThermoInterval>1
            For i=1 To gOW_Thread\ThermoInterval-1
              For x=1 To 10
                Delay(100)
                If gOW_Thread\PortChange Or gOW_Thread\BreakTh
                  Break
                EndIf
              Next x
            Next i
          EndIf
          
        EndIf
      EndIf
    Else
      M1:
      
      CountErr+1
      If CountErr>=10
        Count=0
        SearchSensor(Devices(), Port, @GUI)
        Count = ListSize(Devices())
        GUI\Flags | (#GUI_Update_Flag_StatusBar | #GUI_Update_Flag_Table)
        CountErr=0
      EndIf
      GUI_UpdateInfo(@GUI)
    EndIf
  Until gOW_Thread\BreakTh
    
EndProcedure

Procedure EnumPorts(Gadget)
  Protected i, ID
  
  ClearGadgetItems(Gadget)
    For i=1 To 8
        AddGadgetItem(Gadget, -1, #PortName+i)
    Next
EndProcedure

Procedure OpenWinMain()
  Protected x
 
  OpenWindow(#WinMain, 0, 0, 850, 640, "DS18x20 for Windows, v1.3, 08.12.2019, 75-100", #PB_Window_MinimizeGadget|#PB_Window_Invisible|#PB_Window_ScreenCentered)
  
  CreateMenu(#Menu_Main, WindowID(#WinMain))
  MenuTitle("Файл")
    MenuItem(#MItem_Log, "Записывать в лог-файл")
    MenuBar()
    MenuItem(#MItem_Exit, "Выход")
  
  If CreatePopupMenu(#Menu_TablePopup)
    MenuItem(#MItem_Rename, "Переименовать")
    MenuItem(#MItem_DelSensor, "Удалить не найденные")
  EndIf
  ;
  x=TextGadget(#PB_Any, 704, 20, 100, 16, "Порт:")
  ResizeGadget(x, #PB_Ignore, #PB_Ignore, GadgetWidth(x, #PB_Gadget_RequiredSize)+4, #PB_Ignore)
  ComboBoxGadget(#ComboPort, GadgetX(x)+GadgetWidth(x), 16, 100, 22)
  EnumPorts(#ComboPort)
  ;
  x=ListIconGadget(#Table, 2, 2, 626, 80, "Имя", 90, #PB_ListIcon_GridLines|#PB_ListIcon_FullRowSelect|#PB_ListIcon_AlwaysShowSelection)  
  EnableGadgetDrop(#Table, #PB_Drop_Private, #PB_Drag_Move, #Table)
  SendMessage_(x, #LVM_SETEXTENDEDLISTVIEWSTYLE, 
               #LVS_EX_LABELTIP|#LVS_EX_GRIDLINES|#LVS_EX_DOUBLEBUFFER, 
               #LVS_EX_LABELTIP|#LVS_EX_GRIDLINES|#LVS_EX_DOUBLEBUFFER)
  ;    
  AddGadgetColumn(#Table, #Table_Type, "Тип", 70)
  AddGadgetColumn(#Table, #Table_SN, "Серийный номер", 120)
  AddGadgetColumn(#Table, #Table_Power, "Подключение", 90)
  AddGadgetColumn(#Table, #Table_Thermo, "Температура", 90)
  AddGadgetColumn(#Table, #Table_Status, "Статус", 90)
  AddGadgetColumn(#Table, #Table_Time, "Время", 70)
  
  CreateStatusBar(#StatusBar_Main, WindowID(#WinMain))
  AddStatusBarField(#PB_Ignore)
  
  TextGadget(#TextD1, 640, 286, 200, 90, "00.00", #PB_Text_Center | #PB_Text_Border)
  SetGadgetFont(#TextD1, FontID(#FontBigT))
  TextGadget(#TextD2, 640, 186, 200, 90, "00.00", #PB_Text_Center | #PB_Text_Border)
  SetGadgetFont(#TextD2, FontID(#FontBigT))
  TextGadget(#TextD3, 640, 86, 200, 90, "00.00", #PB_Text_Center | #PB_Text_Border)
  SetGadgetFont(#TextD3, FontID(#FontBigT))
  ;
  SetGadgetColor(#TextD1, #PB_Gadget_FrontColor, ColorCub)
  SetGadgetColor(#TextD1, #PB_Gadget_BackColor, ColorTempFon)
  ;
  SetGadgetColor(#TextD2, #PB_Gadget_FrontColor, ColorTsarga)
  SetGadgetColor(#TextD2, #PB_Gadget_BackColor, ColorTempFon)
  ;
  SetGadgetColor(#TextD3, #PB_Gadget_FrontColor, ColorTroinik)
  SetGadgetColor(#TextD3, #PB_Gadget_BackColor, ColorTempFon)  
   
  HideWindow(#WinMain, #False)
EndProcedure

Procedure ReadSetting()
  Protected String.s, x,Flag, p
  Protected i, TempQ.q
  
  x=OpenPreferences("ThermoMon.ini")
  
  String=ReadPreferenceString("Port", "")
  If String
    SetGadgetText(#ComboPort, String)
  Else
    SetGadgetState(#ComboPort, -1)
  EndIf
  
  gOW_Thread\Log = ReadPreferenceLong("Log", 0)&1
  SetMenuItemState(#Menu_Main, #MItem_Log, gOW_Thread\Log)
  
  gOW_Thread\ThermoInterval =  2
  
  Flag = OW_GetMode()
  Flag|#OW_Mode_Invert
  OW_SetMode(Flag)                 
  
  PreferenceGroup("Sensors")
  p=ReadPreferenceLong("Count", 0)
  If p>100 : p=100 : EndIf
  
  ClearList(g_TableList())
  
  For i=0 To p
    TempQ = ReadPreferenceQuad("ID_"+Str(i), 0)
    If TempQ
      If AddElement(g_TableList())
        PokeQ(@g_TableList()\SN, TempQ)
        g_TableList()\Item[#Table_Name]\Text = ReadPreferenceString("Name_"+Str(i), "Новый")
        g_TableList()\Item[#Table_Name]\Flags=#GUI_Update_Table_Flag_Text
        g_TableList()\Item[#Table_SN]\Text=SN_Text(@TempQ)
        g_TableList()\Item[#Table_SN]\Flags=#GUI_Update_Table_Flag_Text
      EndIf
    EndIf
  Next i
  
  PostEvent(#PB_Event_Gadget, #WinMain, #ComboPort, #PB_EventType_Change)
  
  If x
    ClosePreferences()
  EndIf
EndProcedure

Procedure WriteSetting()
  Protected i=0
  
  If CreatePreferences("ThermoMon.ini")
    
    WritePreferenceString("Port", GetGadgetText(#ComboPort))
    WritePreferenceLong("Log", gOW_Thread\Log)
   
    PreferenceGroup("Sensors")
    WritePreferenceLong("Count", ListSize(g_TableList()))
    
    i=0
    ForEach g_TableList()
      i+1
      WritePreferenceQuad("ID_"+Str(i), PeekQ(@g_TableList()\SN))
      WritePreferenceString("Name_"+Str(i), g_TableList()\Item[#Table_Name]\Text)
    Next
    
    ClosePreferences()
  EndIf
EndProcedure

Procedure PortChange()
  Static Work=#False
  
  If Work=#True
    ProcedureReturn
  EndIf
  
  Work=#True
  
  gOW_Thread\Port=GetGadgetText(#ComboPort)
  gOW_Thread\PortChange = #True
  WriteSetting()
  
  Work=#False
EndProcedure

Procedure GUI_Update(Update = #False)
  Static Work=#False
  Protected GUI.GUI_Update, i
  Protected CountList, CountItem
  Protected Temp, Pos
  
  If Work=#True
    ProcedureReturn
  EndIf
  
  Work=#True
  
  If Update = #False
    LockMutex(gGUI_Update\Mutex)
    If gGUI_Update\Flags
      GUI\Flags=gGUI_Update\Flags
      
      If GUI\Flags & #GUI_Update_Flag_Table
        CopyList(gGUI_Update\Table(), GUI\Table())
      EndIf
      
      If GUI\Flags & #GUI_Update_Flag_StatusBar
        GUI\StatusBarText=gGUI_Update\StatusBarText
      EndIf
      
      gGUI_Update\Flags=0
    Else
      GUI\Flags=0
    EndIf
    UnlockMutex(gGUI_Update\Mutex)
  EndIf
  
  If GUI\Flags & #GUI_Update_Flag_Table Or Update = #True
    
    If Update = #False
      ForEach g_TableList()
        i=#False
        With g_TableList()

          ForEach GUI\Table()
            If PeekQ(\SN) = PeekQ(GUI\Table()\SN)
              i=#True
              Break
            EndIf
          Next
          
          If i=#True
            For i=#Table_Type To #Table_Time
              g_TableList()\Item[i]\Text = GUI\Table()\Item[i]\Text
              g_TableList()\Item[i]\Flags = GUI\Table()\Item[i]\Flags | #GUI_Update_Table_Flag_Text
              g_TableList()\Item[i]\Color = GUI\Table()\Item[i]\Color
            Next i
            \IsFound = #True
            DeleteElement(GUI\Table())
          Else
            \IsFound = #False
            \Item[#Table_Status]\Text = "Не найден"
            \Item[#Table_Status]\Flags = #GUI_Update_Table_Flag_Text
            \Item[#Table_Type]\Flags = #GUI_Update_Table_Flag_Text
            \Item[#Table_Thermo]\Flags = #GUI_Update_Table_Flag_Text
            \Item[#Table_Power]\Flags = #GUI_Update_Table_Flag_Text
          EndIf
          
          \Item[#Table_Name]\Flags = #GUI_Update_Table_Flag_Text
        EndWith
      Next
      
      If ListSize(GUI\Table())>0
        LastElement(g_TableList())
        ForEach GUI\Table()
          If AddElement(g_TableList())
            g_TableList()\SN = GUI\Table()\SN
            g_TableList()\Item[#Table_Name]\Text = "Новый"
            g_TableList()\Item[#Table_Name]\Flags = #GUI_Update_Table_Flag_Text
            For i=#Table_Type To #Table_Time
              g_TableList()\Item[i]\Text = GUI\Table()\Item[i]\Text
              g_TableList()\Item[i]\Flags = GUI\Table()\Item[i]\Flags | #GUI_Update_Table_Flag_Text
              g_TableList()\Item[i]\Color = GUI\Table()\Item[i]\Color
            Next i
          EndIf
        Next
      EndIf
      
    EndIf
    
    CountList = ListSize(g_TableList())
    CountItem = CountGadgetItems(#Table)
    
    If CountList<>CountItem
      ClearGadgetItems(#Table)
      Temp = CountList-1
      For i=0 To Temp
        AddGadgetItem(#Table, i, "")
      Next i
    EndIf
    
    Pos=0
    ForEach g_TableList()
      With g_TableList()
        For i=#Table_Name To #Table_Time
          If GetGadgetItemText(#Table, Pos, i) <> \Item[i]\Text
            SetGadgetItemText(#Table, Pos, \Item[i]\Text, i)
          EndIf
          If \Item[i]\Flags & #GUI_Update_Table_Flag_Color
            SetGadgetItemColor(#Table, Pos, #PB_Gadget_BackColor, \Item[i]\Color, i)
          EndIf
        Next i
        Pos+1
      EndWith
    Next
  EndIf
  
  If GUI\Flags & #GUI_Update_Flag_StatusBar
    StatusBarText(#StatusBar_Main, #StatusBar_Main_Status, GUI\StatusBarText)
  EndIf
  
  Work=#False
EndProcedure

Procedure GUI_UpdateTable()
  GUI_Update(#False)
EndProcedure

Procedure Table_DragDrop(OldPos, NewPos)
   
Protected MoveType, *Point
  
  If OldPos>NewPos
    MoveType=#PB_List_Before ; Перед текущим элементом.
  Else
    MoveType=#PB_List_After  ; После текущего элемента.
  EndIf
  
  If SelectElement(g_TableList(), NewPos)
    *Point = @g_TableList()
    If *Point
      If SelectElement(g_TableList(), OldPos)
        MoveElement(g_TableList(), MoveType, *Point)
        GUI_Update(#True)
      EndIf
    EndIf
  EndIf
  
EndProcedure

Procedure LineXY2(x1, y1, x2, y2, Color)
  LineXY(x1, y1, x2, y2, Color)
  LineXY(x1+1, y1, x2+1, y2, Color)
  LineXY(x1, y1+1, x2, y2+1, Color)
EndProcedure  

Procedure MeterProc(hwnd) 
      *mr.Meter=GetWindowLong_(hwnd,#GWL_USERDATA) 
      If *mr\offset=10 
        *mr\offset=0 
      EndIf 
      For d=0 To *mr\width-1 
        *mr\valuesA[d]=*mr\valuesA[d+1] 
        *mr\valuesB[d]=*mr\valuesB[d+1]
        *mr\valuesC[d]=*mr\valuesC[d+1] 
      Next 
      
      *mr\valuesA[*mr\width-1]=(termoData(0) - LowChartLevel)*(100 / (MaxChartLevel - LowChartLevel)) 
      *mr\valuesB[*mr\width-1]=(termoData(1) - LowChartLevel)*(100 / (MaxChartLevel - LowChartLevel))
      *mr\valuesC[*mr\width-1]=(termoData(2) - LowChartLevel)*(100 / (MaxChartLevel - LowChartLevel))
      StartDrawing(ImageOutput(*mr\PBimg)) 
      
      Box(0,0,*mr\width,*mr\height,ColorTempFon) 
      
      For a = LowChartLevel To MaxChartLevel
        aa = *mr\height-Int(((a - LowChartLevel)*(100 / (MaxChartLevel - LowChartLevel))/100)* *mr\height)
        LineXY(0,aa,*mr\width,aa,ColorSetka) 
      Next
      
      For d=0 To *mr\width 
        LineXY2(d, *mr\height-Int((*mr\valuesA[d]/100)* *mr\height), d, *mr\height-Int((*mr\valuesA[d+1]/100)* *mr\height), ColorCub) 
        LineXY2(d, *mr\height-Int((*mr\valuesB[d]/100)* *mr\height), d+1, *mr\height-Int((*mr\valuesB[d+1]/100)* *mr\height), ColorTsarga)
        LineXY2(d, *mr\height-Int((*mr\valuesC[d]/100)* *mr\height), d+1, *mr\height-Int((*mr\valuesC[d+1]/100)* *mr\height), ColorTroinik)
       Next 
       
      *mr\offset+1 
      StopDrawing() 
      SetWindowLong_(hwnd,#GWL_USERDATA,*mr) 
      SendMessage_(hwnd,#STM_SETIMAGE,#IMAGE_BITMAP,ImageID(*mr\PBimg)) 
EndProcedure 
    
Procedure MeterControl(id.l,x,Y,width,height) 
  image=CreateImage(#PB_Any,width,height) 
  imagegad.l=ImageGadget(id,x,Y,width,height,ImageID(image),#PB_Image_Border) 
  
  hwndreturn=imagegad 
  hwnd=GadgetID(imagegad) 
  
  *mtr.Meter=AllocateMemory(SizeOf(Meter)) 
  *mtr\PBimg=image 
  *mtr\width=width 
  *mtr\height=height 
  SetWindowLong_(hwnd,#GWL_USERDATA,*mtr) 
  ProcedureReturn GadgetID(imagegad) 
EndProcedure 

Procedure CallMeter()
  MeterProc(TheGraph) 
  
  If termoData(0) > 0
    SetGadgetText(#TextD1, StrF(termoData(0), 2))
  Else 
    SetGadgetText(#TextD1, "")
  EndIf 
  If termoData(1) > 0
    SetGadgetText(#TextD2, StrF(termoData(1), 2))
  Else 
    SetGadgetText(#TextD2, "")
  EndIf  
  If termoData(2) > 0
    SetGadgetText(#TextD3, StrF(termoData(2), 2))
  Else 
    SetGadgetText(#TextD3, "")
  EndIf
EndProcedure
 
SetCurrentDirectory(GetPathPart(ProgramFilename()))

OpenWinMain()
ReadSetting()
GUI_Update(#True)

TheGraph=MeterControl(#PB_Any,2,86,624,500) 
SetTimer_(WindowID(0),1,1000,@CallMeter())

Repeat : Until WindowEvent() = 0

BindGadgetEvent(#ComboPort, @PortChange(), #PB_EventType_Change)
BindEvent(#Event_GUI_Update, @GUI_UpdateTable(), #WinMain)

ForEach g_TableList()
  If AddElement(gOW_Thread\SensorList())
    gOW_Thread\SensorList() = g_TableList()\SN
  EndIf
Next

gOW_Thread\Port=GetGadgetText(#ComboPort)
Thread_OW_ID=CreateThread(@Thread_OW(), 0)
OW_SetMode(OW_GetMode()|#OW_Mode_Invert)

Repeat
  Event = WaitWindowEvent()
  Window = EventWindow()
          
  If Window = #WinMain
    If Event = #PB_Event_Menu
      Select EventMenu()
        Case #MItem_Log
          gOW_Thread\Log = GetMenuItemState(#Menu_Main, #MItem_Log)!1
          SetMenuItemState(#Menu_Main, #MItem_Log, gOW_Thread\Log)
          WriteSetting()
        Case #MItem_Exit : Break
        Case #MItem_Rename
          x=GetGadgetState(#Table)
          If x>=0 And x<=ListSize(g_TableList())
            If SelectElement(g_TableList(), x)
              String = InputRequester("Выбор имени датчика", "", g_TableList()\Item[#Table_Name]\Text)
              If String
                If SelectElement(g_TableList(), x)
                  g_TableList()\Item[#Table_Name]\Text = String
                  GUI_Update(#True)
                EndIf
                String=""
              EndIf
            EndIf
          EndIf
        Case #MItem_DelSensor
          ForEach g_TableList()
            If g_TableList()\IsFound = #False
              DeleteElement(g_TableList())
            EndIf
          Next
          GUI_Update(#True)
      EndSelect
      
    ElseIf Event = #PB_Event_Gadget
      Select EventGadget()
        Case #Table
          x = EventType()
          If x = #PB_EventType_DragStart
            Drag_TablePos=GetGadgetState(#Table)
            If Drag_TablePos>=0
              If DragPrivate(#Table, #PB_Drag_Move) <> #PB_Drag_Move
                Drag_TablePos=-1
              EndIf
            EndIf
          ElseIf x = #PB_EventType_RightClick
            x = GetGadgetState(#Table)
            If x>=0
              DisplayPopupMenu(#Menu_TablePopup, WindowID(#WinMain))
            EndIf
          EndIf
          
      EndSelect      
      
    ElseIf Event = #PB_Event_GadgetDrop
      If EventGadget() = #Table
        If EventDropType() = #PB_Drop_Private
          x = GetGadgetState(#Table)
          If x>=0 And Drag_TablePos>=0 And Drag_TablePos<>x
            Table_DragDrop(Drag_TablePos, x)
          EndIf
        EndIf
      EndIf
    EndIf
  EndIf
  
Until Event = #PB_Event_CloseWindow And Window = #WinMain

gOW_Thread\BreakTh=#True
HideWindow(#WinMain, #True)
WriteSetting()
WaitThread(Thread_OW_ID, 400)
If IsThread(Thread_OW_ID)
  KillThread(Thread_OW_ID)
EndIf

If IsFile(#LogFileID)
  CloseFile(#LogFileID)
EndIf

End
; IDE Options = PureBasic 5.70 LTS (Windows - x64)
; CursorPosition = 550
; FirstLine = 462
; Folding = DmC9-
; EnableThread
; EnableXP
; UseIcon = thermometer.ico
; Executable = ..\ThermoMon_x64.exe
; CompileSourceDirectory
; EnablePurifier
; IncludeVersionInfo
; VersionField0 = 1.2.1.0
; VersionField1 = 1.2.1.0
; VersionField2 = Пётр
; VersionField3 = DS18B20 ThermoMon
; VersionField4 = 1.2
; VersionField5 = 1.2
; VersionField6 = DS18B20 термо-мониторинг
; VersionField7 = DS18B20 ThermoMon
; VersionField8 = %EXECUTABLE
; VersionField13 = pure-basic@yandex.ru
; VersionField15 = VOS_NT_WINDOWS32
; VersionField16 = VFT_APP
; VersionField17 = 0419 Russian
; EnableUnicode